import { Collection } from 'mongodb';
export interface IMigration {
    version: string;
    name: string;
    run: (migration: IMigration) => void;
}
interface IOptions {
    log?: boolean;
    logger?: null | Function;
    logIfLatest?: boolean;
    stopIfOldVersionScriptAdded?: boolean;
    stopIfOldVersionScriptUpdated?: boolean;
}
interface IListCollection {
    version: string;
    name: string;
    run: string;
    atDate: Date;
}
interface IStatusCollection {
    _id: string;
    version: string;
    locked: boolean;
    updateAt: Date;
}
export declare class Migrations {
    private static _list;
    private static _statusCollection;
    private static _listCollection;
    private static options;
    static config(statusCollection: Collection<IStatusCollection>, listCollection: Collection<IListCollection>, options?: IOptions): void;
    private static _getControl;
    private static _setControl;
    private static _findIndexByVersion;
    static getExecutedVersions(): Promise<string[]>;
    private static _getAddedAllVersions;
    static findVersionsToExecute(): Promise<string[]>;
    private static _checkIfOldVersionScriptAdded;
    private static _checkIfOldVersionScriptUpdated;
    private static _insertSuccessfullyRanMigration;
    static reset(): Promise<void>;
    static status(): Promise<boolean>;
    static lock(): Promise<import("mongodb").UpdateWriteOpResult>;
    static unlock(): Promise<void>;
    static add(migration: IMigration): void;
    static migrateTo(command: string): Promise<void>;
    private static _migrateTo;
    private static _migrate;
    static saveMigrationWithoutRunning(version: string): Promise<void>;
}
export {};
//# sourceMappingURL=Migrations.d.ts.map